<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="modal-header">
  <h4
    class="modal-title overflow-hidden text-overflow-ellipsis text-nowrap"
    id="modal-basic-title"
    [innerText]="messages.deleteTenantPopupTitle(tenant.name)">
  </h4>
  <button
    type="button"
    class="btn-close"
    [title]="commonMessages.CLOSE"
    (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
  </button>
</div>

<div class="modal-body">
  <div class="text-center">
    <fa-icon
      *ngIf="state === processState.loading"
      [icon]="commonIcons.SPINNER_ICON"
      [spin]="true"
      size="2x">
    </fa-icon>
  </div>
  <div *ngIf="state !== processState.loading">
    <div
      *ngIf="state === processState.tobeProcessed"
      class="alert alert-danger d-flex align-items-center"
      role="alert">
      <fa-icon
        class="pe-2 me-2"
        [icon]="commonIcons.WARNING_ICON">
      </fa-icon>
      <div [innerHTML]="messages.DELETE_TENANT_ALERT_MESSAGE"></div>
    </div>
    <div
      *ngIf="state === processState.processing"
      class="alert alert-danger d-flex align-items-center"
      role="alert">
      <fa-icon
        class="pe-2"
        [icon]="commonIcons.WARNING_ICON">
      </fa-icon>
      <div
        class="font-text-bold"
        [innerText]="messages.DELETE_TENANT_PROCESSING_MESSAGE">
      </div>
    </div>
    <div
      *ngIf="state === processState.failure"
      class="alert alert-warning"
      role="alert">
      <fa-icon
        class="pe-2"
        [icon]="commonIcons.WARNING_ICON">
      </fa-icon>
      {{ messages.DELETE_TENANT_FAILURE_MESSAGE }}
    </div>
    <div
      *ngIf="state === processState.done"
      class="alert alert-success d-flex align-items-center"
      role="alert">
      <fa-icon
        class="pe-2"
        [icon]="commonIcons.VALIDATED_ICON">
      </fa-icon>
      <div [innerHTML]="messages.DELETE_TENANT_SUCCESS_MESSAGE"></div>
    </div>
    <form class="ls-form col">
      <div class="form-group">
        <label [innerText]="messages.DELETE_TENANT_FORM_LIST_LABEL"></label>
        <ul>
          <li
            *ngFor="let item of items"
            [ngClass]="{'text-warning': item.state === processState.failure}"
            class="d-flex">
            <div class="w-50 position-relative">
              <div class="w-50 position-absolute">
                <fa-icon
                  [icon]="getIcon(item)"
                  [ngClass]="{'text-success': item.state === processState.done}"
                  [spin]="item.state === processState.processing">
                </fa-icon>
              </div>
              <span
                class="ms-4"
                [innerText]="(item.value ?? '0') + ' ' + commonMessages.getPluralized(item.name, item.value)">
              </span>
            </div>
            <div
              *ngIf="item.state === processState.processing || item.state === processState.done "
              class="w-25 p-2">
              <div class="progress individual-progress-bar">
                <div
                  [attr.aria-valuenow]="getProgressPerCentForItem(item)"
                  [ngClass]="{'progress-bar-animated' : !(item.state === processState.done)}"
                  [ngStyle]="{'width' : getProgressPerCentForItem(item)+'%'}"
                  aria-valuemax="100"
                  aria-valuemin="0"
                  class="progress-bar progress-bar-striped" role="progressbar">
                </div>
              </div>
            </div>
          </li>
        </ul>
      </div>
      <div class="form-group required">
        <label
          [innerText]="messages.DELETE_TENANT_FORM_CONFIRM_LABEL"
          for="confirmTenantNameInput">
        </label>
        <div>
          <span
            [innerText]="tenant.name"
            [ngbTooltip]="tenant.name"
            class="badge rounded-pill bg-light text-dark mb-2 mt-2 max-width-100 overflow-hidden text-overflow-ellipsis">
          </span>
        </div>
        <input
          id="confirmTenantNameInput"
          (ngModelChange)="onChange($event)"
          [(ngModel)]="confirmTenantName"
          class="form-control"
          required
          type="text">
      </div>
    </form>
    <div
      *ngIf="processState.processing === state || processState.done === state"
      class="main-progress-bar progress">
      <div
        [attr.aria-valuenow]="getProgressPerCent()"
        [ngStyle]="{'width' : getProgressPerCent()+'%'}"
        [ngClass]="{'progress-bar-animated' : processState.processing === state}"
        aria-valuemax="100"
        aria-valuemin="0"
        class="progress-bar progress-bar-striped" role="progressbar"
        [innerText]="getProgressPerCent() + '%'">
      </div>
    </div>
  </div>
</div>

<div class="modal-footer">
  <button
    ls-button-cancel
    (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)"
    *ngIf="processState.done !== state"
    [disabled]="processState.processing === state">
  </button>
  <button
    ls-button
    (click)="onDeleteButtonClicked()" *ngIf="processState.done !== state"
    [disabled]="processState.loading === state || !isFormValid"
    [icon]="commonIcons.DELETE_ICON"
    [processing]="processState.processing === state"
    [style]="styles.DANGER"
    [text]="messages.DELETE_TENANT">
  </button>
  <button
    ls-button
    *ngIf="processState.done === state"
    (click)="activeModal.close(this.commonMessages.ACTION_RESULT_OK)"
    [icon]="commonIcons.CLOSE_ICON"
    [text]="commonMessages.CLOSE">
  </button>
</div>
